(load "slides")

(presentation

 (cover
  `((h1 "Servidores Linux")
    (p "Mario Domenech Goulart")
    (address "mario.goulart@gmail.com")
    ))


 (slide "Sobre o curso"
        `(ul
          (li "Enfoque: " (strong "fundamentos") " de sistemas Linux (software básico)")
          (li "Aspectos indispensáveis para administração de sistemas Linux")
          ))


(slide "Administradores de sistemas"
       `(ul
         (li "Ética")
         (li "Responsabilidade")
         (li "Conhecimento técnico")))


(slide "Servidores"
       `((ul
          (li "Fornecem serviços (normalmente associados a redes de computadores)")
          (li "Software + hardware"))

         (h3 "Aspectos")
         (ul
          (li "Desempenho")
          (li "Alta disponibilidade")
          (li "Segurança"))))


 (slide "Pré-história"
        `((h2 "CTSS")
          (ul
           (li (b "C") "ompatible " (b "T") "ime-" (b "S") "haring " (b "S") "ystem")
           (li "1961")
           (li "Implementação do conceito de " (i "time-sharing")))

          (h2 "Multics")
          (ul
           (li (b "Mult") "iplexed " (b "I") "nformation and " (b "C") "omputing " (b "S") "ervice")
           (li "1964")
           (li "Computação como serviço")
           )))

 (slide "Unix"
        `(ul
          (li "Trocadilho com o nome Multics")
          (li "1969")
          (li "Caracterizado por sua API")
          (li "Exemplos: BSD, Minix, HP-UX, AIX")
          ))


(slide "Unix -- características"
       `((ul
          (li "Multiusuário")
          (li "Multitarefa")
          (li "Componentes simples"
              (ul
               (li "Cada componente deve executar uma única tarefa")
               (li "Múltiplos componentes podem ser combinados para executar tarefas complexas"))))))


(slide "Linux"
       `(ul
         (li "Trocadilho com o nome do autor (Linus Torvalds) e Unix")
         (li "1991")
         (li "Kernel")
         (li "Baseado em Unix")
         (li "Feito em C")
         (li "Código aberto")))


(slide "O projeto GNU"
       `(ul
         (li "Iniciado por Richard Stallman, em 1983")
         (li "Objetivo: criar um sistema completo, compatível com Unix")
         (li "Mantido pela Free Software Foundation (FSF)")
         (li "Emacs, GCC, GDB, make, GAS, Bash")
         ))


(slide "GNU/Linux -- Distribuições"
       `(ul
         (li "Kernel (Linux) + aplicativos")
         (li "Exemplos: Debian, Fedora, Arch, Gentoo, Ubuntu, Slackware")
         (li "Linha do tempo de distribuições: "
             (a (@ (href "http://futurist.se/gldt/")) "http://futurist.se/gldt/"))
         ))


(slide "Organização de sistemas Linux"
       `(ul
         (li "Kernel e drivers")
         (li "Shell e programas")
         (li "Usuários e grupos")
         (li "Estrutura e hierarquia de arquivos e diretórios")))


(slide "Organização de sistemas Linux"
       `(img (@ (src "img/unix-estrutura.png"))))


(slide "Kernel e drivers"
       `(ul
         (li "Interface entre o hardware e programas dos usuários")
         (li "API -> " (i "system calls"))
         (li "Gerenciamento de recursos"
             (ul
              (li "Processos")
              (li "Memória")
              (li "Entrada e saída")
              (li "Espaço de armazenamento")))))


(slide "Processos"
       `(ul
         (li "Também chamados de " (i "programas"))
         (li "Um processo é um programa em execução")
         (li "Fazem uso das " (i "system calls") " fornecidas pelo kernel")
         (li "Só conseguem acesso de recursos do hardware através de chamadas ao kernel")
         (li "Gerenciados pela parte do kernel chamada de " (i "escalonador de processos"))
         (li "Cada processo tem uma série de propriedades, como um identificador numérico, área de memória e lista de arquivos abertos")
         (li "Cada processo possui um dono (usuário)")
         ))


(slide "Usuários e grupos"
       `(ul
         (li "Uma das formas de determinação de " (i "permissões"))
         (li "Superusuário (root) e usuários normais")
         ))


(slide "Usuários"
       `(ul
         (li "Identificados por um identificador numérico (id) e um nome")
         (li "Tradicionalmente root: id = 0")
         (li "Convencionalmente, identificadores de valor mais baixo são usados para usuários representando serviços do sistema")
         (li "Usuários \"humanos\": normalmente possuem um diretório (" (i "home") ") e uma senha para acesso ao sistema")
         ))


(slide "Grupos"
       `(ul
         (li "Agrupam usuários com características comuns")
         (li "Convencionalmente, identificadores de valor mais baixo são usados para grupos que envolvem serviços do sistema")
         ))


(slide "Arquivos"
       `(ul
         (li "Arquivos: contêiners de dados")
         (li "Identificados por um nome")
         (li "Maiúsculas e minúsculas são diferentes")
         (li "Diretórios: arquivos especiais que podem conter arquivos")
         (li "Arquivos \"ocultos\": nome iniciado por " (code "."))
         (li (i "Links") ": apontadores para arquivos")
         ))


(slide "Organização de arquivos"
       `((ul
          (li "Estrutura de dados: árvore")
          (li "Nodo raíz: " (code "/") " (raíz, barra)")
          (li "Separador de nomes de arquivos: " (code "/")))
         (img (@ (src "img/arquivos-estrutura.png")))))


(slide "Estrutura de diretórios"
       `((ul
          (li (code "/") ": diretório raíz")
          (li (code "/bin") ": programas básicos para inicialização do sistema")
          (li (code "/etc") ": arquivos de configuração")
          (li (code "/usr/bin") ": arquivos executáveis não estritamente necessários para a inicialização do sistema")
          (li (code "/tmp") ": diretório para arquivos temporários")
          (li (code "/var") ": arquivos de registro de dados programas (\"variáveis\")")
          (li (code "/proc") ": dados do kernel representados sob forma de uma hierarquia de diretórios")
          (li (code "/opt") ": normalmente usado para armazenamento de programas instalados manualmente no sistema")
          (li (code "/sbin") ": programas básicos para inicialização do sistema, cuja execução normalmente é feita pelo usuário root")
          (li (code "/root") ": diretório do usuário root")
          (li (code "/home") ": diretório a partir do qual são criados os diretórios dos usuários")
          (li (code "/boot") ": arquivos básicos para a inicialização do sistema (kernel, configuração do boot loader)")
          )))


(slide "Sistemas de arquivos"
       `((ul
          (li "Software (usualmente no espaço do kernel) e estrutura de dados")
          (li "Funcionalidades básicas:"
              (ul
               (li "Gerenciamento do espaço de armazenamento (normalmente não volátil)")
               (li "Cache (operações de entrada/saída são caras)")))
          (li "Funcionalidades extras:"
              (ul
               (li "Compactação")
               (li (i "Journaling"))
               (li "Criptografia")))
          (li "Exemplos: ext2, ext3, ext4, Reiserfs, Butterfs, ZFS, XFS")
          )))


(slide "Inicialização de um sistema linux"
       `((div (@ (class "left"))
              (img (@ (src "img/boot.png"))))
         (ul (@ (style "margin-left: 300px"))
             (li "BIOS (" (i "Basic Input/Output System") "): firmware")
             (li "MBR (" (i "Master Boot Record") "): área de 512 bytes que contém o primeiro estágio do Boot Loader e uma tabela de partições")
             (li "Boot Loader: carrega o kernel")
             (li "Kernel: configura o hardware (drivers), monta sistemas de arquivos e inicia o processo pai de todos")
             (li "init (" (code "/sbin/init") "): processo a partir do qual todos os outros são criados.  Lê " (code "/etc/inittab"))
             )))



;;;
;;; Shell
;;;

(slide "Shell -- introdução"
       `(ul
         (li "É um programa")
         (li "Interpretador de comandos")
         (li "Linguagem de programação")
         (li "Exemplos: sh, bash, csh, ksh, zsh, busybox")
         ))


(slide "Comandos"
       `(ul
         (li "Sintaxe: " (code "<comando> [ <argumentos> ]"))
         (li "Maiúsculas e minúsculas são diferentes")
         (li "Comandos internos (builtins) & processos")
         ))


(slide "Comando pwd"
       `((ul
          (li "Mostra o caminho corrente (" (i "Print Working Directory") ")")
          (li "Comando interno")
          )
         (h3 "Exemplo")
         (pre "$ pwd")))


(slide "Comando which"
       `((ul
          (li "Mostra a localização de um programa")
          )
         (h3 "Exemplo")
         (pre "$ which which")))


(slide "Comando echo"
       `((ul
          (li "Imprime caracteres")
          )
         (h3 "Exemplo")
         (pre "$ echo Boa noite")))


(slide "Comando ls"
       `((ul
          (li "Lista arquivos")
          (li "Opções usuais:"
              (ul
               (li (code "-l") ": mostra detalhes")
               (li (code "-h") ": mostra tamanhos com multiplicador (K, M, G)")
               (li (code "-a") ": mostra arquivos \"ocultos\"")
               (li (code "-d") ": mostra propriedades de diretórios em vez do conteúdo")
               (li (code "--sort=<opção>") ": ordena por " (code "<opção>")
                   (ul
                    (li (code "extension"))
                    (li (code "size"))
                    (li (code "time"))))
               )))))


(slide "ls -- exemplos"
       `((pre "$ ls")
         (pre "$ ls -a")
         (pre "$ ls -la")
         (pre "$ ls /")
         (pre "$ ls /etc")
         (pre "$ ls -l /etc")))


(slide "ls -- exemplos (continuação)"
       `((pre "$ ls -d /etc")
         (pre "$ ls -ld /etc")
         (pre "$ ls -l /boot")
         (pre "$ ls -lh /boot")
         (pre "$ ls -l --sort=size /boot")
         ))



(slide "Comando date"
       `((ul
          (li "Mostra data/hora do sistema")
          )
         (h3 "Exemplo")
         (pre "$ date")))


(slide "Comando type"
       `((ul
          (li "Identifica o tipo de comando"))
         (h3 "Exemplos")
         (pre "$ type type") ; builtin
         (pre "$ type which") ; link
         (pre "$ type ls") ; alias
         (pre "$ type date") ; bin
         ))


(slide "Comando cat"
       `((ul
          (li "Concatenação de arquivos")
          )
         (h3 "Exemplos")
         (pre "$ cat /etc/motd")
         (pre "$ cat /etc/motd /etc/motd")))


(slide "Comando cd"
       `((ul
          (li "Troca de diretório (" (i "Change Directory") ")")
          )
         (h3 "Exemplos")
         (pre "$ cd /etc")
         (pre "$ cd /")
         (pre "$ cd")
         (pre "$ cd -")))



(slide "Shell -- variáveis de ambiente"
       `(ul
         (li "Shells determinam ambientes, os quais podem conter variáveis")
         (li "Extração de valores de variáveis: " (code "$"))
         (li "Atribuição de valores a variáveis: " (code "="))
         (li "Exemplos de variáveis padrão:"
             (ul
              (li (code "USER") ": usuário corrente")
              (li (code "HOME") ": diretório do usuário")
              (li (code "PWD") ": diretório corrente")
              (li (code "PATH") ": diretórios onde o shell procura por programas")
              ))))


(slide "Entrada/saídas padrão"
       `(ul
         (li "Entrada padrão (" (i "stdin") " -- 0)")
         (li "Saída padrão (" (i "stdout") " -- 1)")
         (li "Saída padrão de erro (" (i "stderr") " -- 2)")))



(slide "Shell -- redirecionamento de entrada e saída"
       `((ul          (li (code "<") ": redirecionamento de entrada")
          (li (code ">") ": redirecionamento de saída")
          (li (code ">>") ": redirecionamento de saída (" (i "append") ")")
          )
         (h3 "Exemplos")
         (pre "$ echo 1 > arquivo.txt")
         (pre "$ echo 2 > arquivo.txt")
         (pre "$ echo 3 >> arquivo.txt")
         (pre "$ cat > arquivo.txt")
         (pre "$ cat < arquivo.txt > outro.txt")))


(slide "Shell -- redirecionamento de entrada e saída"
       `((pre "$ ls /etc 2>erro >ok")
         (pre "$ ls /blablabla 2>erro >ok")
         (pre "$ ls /etc > tudo 2>&1")
         (pre "$ ls /etc >> tudo 2>&1")))


(slide "Shell -- Pipes"
       `((ul
          (li "Conectam entradas e saídas de processos")
          )
         (h3 "Exemplos")
         (pre "$ ls | more")
         (pre "$ echo oba | wc -m")
         (pre "$ echo -n oba | wc -m")
         (pre "$ cat /etc/motd | head -n3")
         (pre "$ cat /etc/motd | tail -n2")
         ))


(slide `("Gerenciamento de tarefas (" (i "jobs") ")")
       `((ul
          (li (code "&") ": coloca processo em " (i "background"))
          (li (code "C-z") ": suspende processo")
          (li (code "bg") ": coloca processo em " (i "background"))
          (li (code "fg") ": coloca processo em " (i "foreground")))
         (h3 "Exemplos")
         (pre "$ sleep 5 &")
         (pre "$ sleep 10
C-z
$ bg
$ fg")))


(slide "Gerenciamento de processos -- listagem"
       `((ul
          (li (code "ps") ": lista processos"))
         (h3 "Exemplos")
         (pre "$ ps")
         (pre "$ ps ax")
         (pre "$ ps aux")
         (pre "$ ps faux")))


(slide "Gerenciamento de processos -- sinais"
       `((ul
          (li (code "kill") ": envia sinais para processos"
              (ul
               (li "Normalmente usado para finalizar processos")
               (li "Sintaxe: " (code "kill [ <sinal> ] <pid ou %id do job>"))
               ))
          (li "Sinais comumente usados"
              (ul
               (li (code "TERM") " (15 -- default): término \"tratável\"")
               (li (code "KILL") " (9): término \"não tratável\"")
               (li (code "HUP") " (1): reinicia")
               )))
         (h3 "Exemplos")
         (pre "$ sleep 10h &")
         (pre "ps")
         (pre "kill <pid do sleep>")
         ))


(slide "Gerenciamento de processos -- código de saída"
       `((ul
          (li (code "exit"))
          (li "Sucesso: 0")
          (li "Falha: 1 -- 255")
          (li "Variável do shell que indica o código de saída do último processo executado: " (code "$?")))))


(slide "Gerenciamento de processos -- execução incondicional e condicional"
       `((ul
          (li "Execução incondicional: " (code "programa1 ; programa2"))
          (li "Execução condicional (e): " (code "programa1 && programa2")
              (ul
               (li "Só executa " (code "programa2") " se " (code "programa1") " for finalizado com sucesso")))
          (li "Execução condicional (e): " (code "programa1 || programa2")
              (ul
               (li "Executa " (code "programa2") " quando " (code "programa1") " falhar")))
          )))


(slide "Daemons"
       `(ul
         (li "Executados em background")
         (li "Seguidamente têm nome com d como sufixo (exemplo: udevd, syslogd)")
         (li "Executados desassociado de termimais")
         (li "Usam / como diretório de execução (para não bloquear a desmontagem de sistemas de arquivos)")
         ))


(slide "Monitoramento de processos -- top"
       `((ul
          (li (code "Shift + f") ": seleciona critérios de ordenação"
              (ul
               (li (code "n + ENTER") ": ocupação de memória")
               (li (code "k + ENTER") ": uso de CPU")))
          (li (code "k") ": atalho para matar processo")
          (li "Alternativas: htop, atop")
          )))


(slide "Gerenciamento de processos -- exercícios"
       `((p "Execute o comando mostrado abaixo e:")
         (ol
          (li "suspenda-o")
          (li "coloque-o em background")
          (li "coloque-o em foreground")
          (li "suspenda-o novamente")
          (li "coloque-o em background novamente")
          (li "finalize-o"))
         (pre "$ yes > /dev/null")))


(slide `("Bibliotecas de carga dinâmica (DLLs) -- " (code "ldd"))
       `((ul
          (li (code "ldd") ": exibe as bibliotecas com as quais o programa dado como argumento está ligado")
          (li (code "LD_LIBRARY_PATH") ": variável de ambiente que especifica o caminho a ser pesquisado em busca de bibliotecas de carga dinâmica")
          (li (code "LD_PRELOAD") ": variável de ambiente que permite alterar a precedência de carga de bibliotecas (sobrescrita de símbolos)")
          )))


(slide `("Gerenciamento de arquivos -- " (i "globbing"))
       `((ul
          (li "Casamento de padrões")
          (li (i "Wildcards") " (caracteres curinga)")
          (li (code "*") ": zero ou mais caracteres")
          (li (code "?") ": qualquer caracter")
          (li (code "[]") ": qualquer um dos caracteres")
          (li (code "{}") ": aplica padrão")
          )))


(slide "Gerenciamento de arquivos"
       `((ul
          (li (code "rm") ": apaga")
          (li (code "cp") ": copia")
          (li (code "mv") ": move")
          (li (code "ln") ": aponta")
          (li (code "rmdir") ": apaga diretórios vazios")
          (li (code "mkdir") ": cria diretórios")
          (li (code "touch") ": atualiza hora/data de acesso e modificação de arquivos")
          )
         ))


(slide `("Gerenciamento de arquivos -- " (i "globbing") ", exemplos")
       `((h3 "Exemplos")
         (pre "$ touch arq.txt arq1.txt arq2.txt arq3.txt arq3.cpp")
         (pre "$ ls arq*")
         (pre "$ ls arq?.txt")
         (pre "$ ls arq[12].txt")
         (pre "$ ls arq3.{txt,cpp}")
         (pre "$ ls arq?.{txt,cpp}")))


(slide "Gerenciamento de arquivos -- permissões"
       `((table (@ (id "perms")
                   (border 1))
          (tr (td "Tipo")
              (td "Dono (r)")
              (td "Dono (w)")
              (td "Dono (x)")
              (td "Grupo (r)")
              (td "Grupo (w)")
              (td "Grupo (x)")
              (td "Outros (r)")
              (td "Outros (w)")
              (td "Outros (x)")))
         (ul
          (li "Tipo"
              (ul
               (li (code "-") ": arquivo regular")
               (li (code "d") ": diretório")
               (li (code "l") ": link")
               (li (code "b") ": dispositivo de bloco")
               (li (code "c") ": dispositivo de caracteres"))))
         (ul
          (li (code "r") ": leitura")
          (li (code "w") ": escrita")
          (li (code "x") ": execução"))))


(slide "Gerenciamento de arquivos -- chmod"
       `((ul
          (li (code "chmod") ": modifica permissões de arquivos e diretórios")
          (li "Sintaxe: " (code "chmod <permissões> <arquivos>"))
          (li "Operação recursiva: opção " (code "-R")))
         (h3 "Exemplos")
         (pre "$ chmod 644 arquivo")
         (pre "$ chmod 755 diretorio")))


(slide "Gerenciamento de arquivos -- chown"
       `((ul
          (li (code "chown") ": altera dono/grupo de arquivos e diretórios")
          (li "Sintaxe: " (code "chown <dono>:<grupo> <arquivos>"))
          (li "Operação recursiva: opção " (code "-R")))
         (h3 "Exemplo")
         (pre "$ chmod mario:users /home/mario/arq.txt")
         ))


(slide "Gerenciamento de arquivos -- stat"
       `((ul
          (li (code "stat") ": exibe informações sobre arquivos"))
         (h3 "Exemplo")
         (pre (@ (style "font-size: 80%"))
              "$ stat index.scm
  File: \"index.scm\"
  Size: 29992           Blocks: 64         IO Block: 4096   arquivo comum
Device: 806h/2054d      Inode: 435698      Links: 1
Access: (0644/-rw-r--r--)  Uid: ( 1000/   mario)   Gid: ( 1000/   mario)
Access: 2012-03-19 17:58:42.000000000 -0300
Modify: 2012-03-19 18:00:10.000000000 -0300
Change: 2012-03-19 18:00:10.000000000 -0300")))


(slide "Gerenciamento de arquivos -- exercícios"
       `((p "Crie os arquivos a seguir e atribua a eles as seguintes permissões:")
         (ul
          (li (code "arquivo1.txt")
              (ul
               (li "Dono pode ler, escrever e executar")
               (li "Membros do grupo podem apenas ler")
               (li "Outros podem apenas ler")))
          (li (code "arquivo2.txt")
              (ul
               (li "Dono pode ler, escrever e executar")
               (li "Membros do grupo podem ler e executar")
               (li "Outros não podem nem ler, executar nem escrever"))))))

(slide "Gerenciamento de arquivos -- exercícios (continuação)"
       `(ul
         (li (code "diretorio1")
             (ul
              (li "O dono pode entrar nesse diretório, listar seu conteúdo e escrever nele")
              (li "Membros do grupo e outros não podem fazer nada")))
         (li (code "diretorio2")
             (ul
              (li "O dono pode entrar nesse diretório. listar seu contúdo e escrever nele")
              (li "Membros do grupo podem entrar no diretório e listar o conteúdo, mas não podem escrever")
              (li "Outros não podem fazer nada")))))


(slide "Gerenciamento de arquivos -- find"
       `((ul
          (li (code "find") ": localiza arquivos no sistema de arquivos")
          )
         (h3 "Exemplos")
         (pre "$ find /etc -name \"mot*\"")
         (pre "$ find /etc -iname \"mot*\"")
         (pre "$ find /etc -type d")
         (pre "$ find /etc -maxdepth 1 -type d | wc -l")
         (pre "$ find /etc -maxdepth 2 -type d | wc -l")
         (pre "$ find /home -user $USER -maxdepth 1")
         ))


(slide "xargs"
       `((ul
          (li (code "xargs") ": executa comandos com argumentos da entrada padrão")
          (li "Frequentemente usado com a saída do programa " (code "find"))
          )
         (h3 "Exemplo")
         (pre "$ find /etc -maxdepth 1 -type d | xargs du")
         ))


(slide "Gerenciamento de arquivos -- compactação"
       `((ul
          (li (code "tar") ": \"aglomerador\" de arquivos")
          (li "Compactadores: gzip, zip, bzip2, compress")
          )))


(slide "Gerenciamento de arquivos -- exercício"
       `((p "Execute o programa " (code "cria-arquivos") " e apague os arquivos criados por ele, um de cada vez")
         (pre "$ ./cria-arquivo")))





;;; Instalação
(slide "Instalação básica de um sistema Debian"
       `((ul
          (li "Arquivo com o instalador: "
              (a (@ (href "http://www.c3.furg.br/arquivos/download/debian-6.0.4-i386-CD-1.iso"))
                 "http://www.c3.furg.br/arquivos/download/debian-6.0.4-i386-CD-1.iso"))
          )))


(slide "Debian -- pacotes"
       `((ul
          (li "APT " (i "Advanced Package Tool") ": ferramenta para gerenciamento de pacotes")
          (li "Instalação de pacotes: " (code "apt-get install <pacotes>"))
          (li "Remoção de pacotes: " (code "apt-get remove <pacotes>"))
          (li "Informações sobre pacote: " (code "apt-cache show <pacote>"))
          (li "Configuração de repositórios de pacotes: " (code "/etc/apt/sources.list"))
          )))



(slide "Ferramentas -- sort"
       `((ul
          (li "Requer que a entrada esteja ordenada"
              (ul
               (li "Opção " (code "-u"))
               (li "Programa " (code "uniq"))))
          (li "Algumas opções:"
              (ul
               (li (code "-r") ": ordenação reversa")
               (li (code "-g") ": ordenação numérica"))))
         (h3 "Exemplo")
         (pre "$ sort /etc/passwd")
         ))


(slide "Ferramentas -- multiplexadores de terminais"
       `((ul
          (li "Permite o uso de múltiplos terminais na mesma janela")
          (li "Úteis para deixar programas em execução em sistemas remotos depois de encerrada a conexão")
          (li "Exemplos: screen, tmux"))))


(slide "Ferramentas -- screen"
       `((ul
          (li (code "screen") ": inicia uma sessão")
          (li (code "screen -r") ": reconecta à sessão")
          (li (code "screen -ls") ": lista sessões")
          (li "Teclas:"
              (ul
               (li (code "C-a c") ": cria um novo terminal")
               (li (code "C-a d") ": desconecta da sessão corrente")
               (li (code "C-a <n>") ": alterna para terminal <n>"))))))



(slide "Expressões regulares -- introdução"
       `((ul
          (li "Casamento de padrões de texto")
          (li "Amplamente usadas por ferramentas do Unix")
          )))


(slide "Expressões regulares -- básico"
       `((ul
          (li (code "^") ": início de linha")
          (li (code "$") ": fim de linha")
          (li (code ".") ": um caracter qualquer")
          (li (code "*") ": zero ou mais caracteres")
          (li (code "+") ": um ou mais caracteres")
          (li (code "[]") ": faixa de caracteres")
          )))


(slide "Ferramentas -- grep"
       `((ul
          (li "Procura por padrões em strings")
          (li "Opções usuais:"
              (ul
               (li (code "-r") ": modo recursivo")
               (li (code "-A<n>") ": mostra " (code "n") " linhas após a ocorrência do padrão procurado")
               (li (code "-B<n>") ": mostra " (code "n") " linhas antes da ocorrência do padrão procurado")
               (li (code "-C<n>") ": mostra " (code "n") " linhas antes e depois da ocorrência do padrão procurado")
               (li (code "-v") ": mostra linhas que " (strong "não") " casam com o padrão")
               (li (code "-i") ": diferencia maiúsculas e minúsculas"))))
         (h3 "Exemplos")
         (pre "$ grep 'model name' /proc/cpuinfo  | head -n1")
         (pre "$ ps aux | grep ^root")
         ))


(slide "Exercícios -- grep"
       `((p "Usando " (code "grep") ":")
         (ul
          (li "imprima apenas a linha correspondente ao seu usuário em " (code "/etc/passwd"))
          (li "em combinação com " (code "ls") " liste apenas os diretórios em " (code "/etc"))
          (li "em combinação com " (code "ps aux") " liste apenas os seus processos")
          (li "imprima apenas as linhas que não são comentários em " (code "/boot/grub/menu.lst"))
          (li "em combinação com " (code "ls") ", liste todos os diretórios em " (code "/etc") " com permissão de escrita, leitura e execução para o dono")
          )))


(slide "Ferramentas -- sed"
       `((ul
          (li "Editor de streams")
          (li "Alguns comandos:"
              (ul
               (li "Substituição (s)"
                   (pre "$ ls -l | sed \"s/$USER//g\""))
               (li "Remoção (d)"
                   (pre "$ ls -l / | sed \"/^d/d\""))))
          )))


(slide "Exercícios -- sed"
       `((p "Usando " (code "sed") ":")
         (ul
          (li "em combinação com " (code "ls -l") ", elimine a primeira coluna (que contém as permissões) da listagem de arquivos e diretórios")
          (li "substitua as ocorrências de " (code "title") " em " (code "/boot/grub/menu.lst") " por " (code "titulo"))
          )))


;;;
;;; Gerenciamento do sistema
;;;

(slide "Gerenciamento do sistema serviços"
       `((h3 "Em sistemas Debian")
         (ul
          (li (code "/etc/init.d") ": scripts para gerenciamento de serviços")
          (li "Ações padrão:"
              (ul
               (li "start")
               (li "stop")
               (li "restart")
               (li "reload")))
          (li "Habilitação/desabilitação de serviços: " (code "update-rc.d")))))


(slide "Gerenciamento do sistema -- usuários e grupos"
       `((ul
          (li "Informação sobre usuário: " (code "id"))
          (li "Criação de usuários: " (code "adduser"))
          (li "Remoção de usuários: " (code "deluser"))
          (li "Criação de grupos: " (code "addgroup"))
          (li "Remoção de grupos: " (code "delgroup"))
          (li (code "/etc/passwd"))
          (li (code "/etc/group"))
          )))


(slide "Gerenciamento do sistema -- limites"
       `((ul
          (li (i "Fork bomb") ": " (code ":(){ :|:& };:"))
          (li (code "ulimit") ": especificação de limites por shell"
              (ul
               (li "Configuração: " (code "/etc/profile"))))
          (li (code "pam_limits")
              (ul
               (li "Configuração: " (code "/etc/security/limits.conf"))))
          (li "Kernel"
              (ul
               (li (code "/proc/sys/fs/file-max"))
               (li (code "/proc/sys/kernel/threads-max"))))
          )))


(slide "Gerenciamento do sistema -- partições e sistemas de arquivos"
       `((ul
          (li (code "fdisk") ": particionador")
          (li (code "fsck") ": verificação de integridade e para correção de erros em sistemas de arquivos (específica para cada tipo de sistema de arquivos)")
          (li (code "mkfs") ": criação de sistemas de arquivos")
          (li (code "mount") ": montagem de sistemas de arquivos")
          (li (code "umount") ": desmontagem de sistemas de arquivos")
          (li (code "sync") ": escrita em disco de dados dos sistemas de arquivos em memória"))))


(slide "Exercício de manipulação de sistema de arquivos"
       `((p "Criação e montagem de um sistema de arquivos em arquivo")
         (pre "
# dd if=/dev/zer of=sistema-de-arquivos bs=1k count=10000
# mkfs.ext3 sistema-de-arquivos
# mkdir ponto-de-montagem
# mount -o loop sistema-de-arquivos ponto-de-montagem
# umount ponto-de-montagem
")))


(slide "Agendamento de tarefas -- cron"
       `((ul
          (li "Crontab")
          (li "Cronjobs")
          (li "Edição: " (code "crontab -e"))
          (li "Editor: pode ser especificado através da variável de ambiente " (code "EDITOR"))
          )
         (h3 "Sintaxe")
         (pre "<minuto> <hora> <dia do mês> <mês> <dia da semana> <comando>")))


(slide "Agendamento de tarefas -- exemplos"
       `((dl
          (dt (code "30 13 * * * <comando>"))
          (dd "Executa " (code "<comando>") " uma vez por dia, todos os dias, às 13:30h")

          (dt (code "0 12 * * 3 <comando>"))
          (dd "Executa " (code "<comando>") " uma vez por semana, na quarta-feira, todos os meses, às 12h")

          (dt (code "0,15,30,45 * * * * <comando>"))
          (dd "Executa " (code "<comando>") " de quinze em quinze minutos"))))


(slide "Monitoramento do sistema -- uptime"
       `((ul
          (li (code "uptime") " : exibe informações como, por exemplo, tempo de atividade do servidor, número de usuários conectados ao sistema e carga nos últimos 1, 5 e 15 minutos."))
         ))


(slide "Monitoramento do sistema -- ocupação de sistemas de arquivos"
       `((ul
          (li (code "df") ": exibe informações sobre utilização de espaço por sistema de arquivos montado")
          (li "Opção " (code "-h") ": usa multiplicadores como sufixo de valores"))))


(slide "Monitoramento do sistema -- memória"
       `((ul
          (li (code "free") ": exibe informações sobre a memória do sistema"))
         (h3 "Exemplo")
         (pre (@ (style "font-size: 80%"))
          "$ free
             total       used       free     shared    buffers     cached
Mem:       3057824    2583928     473896          0     420600    1170208
-/+ buffers/cache:     993120    2064704
Swap:       514040       3992     510048")))


(slide "Monitoramento do sistema -- arquivos de log"
       `((ul
          (li "Diretório de logs: " (code "/var/log"))
          (li "Logs do sistema:"
              (ul
               (li (code "/var/log/syslog"))
               (li (code "/var/log/dmesg"))
               (li (code "/var/log/debug"))
               (li (code "/var/log/daemon.log"))))
          (li "Gerenciamento de logs: " (code "logrotate")
              (ul
               (li "Compressão")
               (li "Rotacionamento")
               )))))


(slide "Kernel e módulos"
       `((ul
          (li "Versão: " (code "uname -r"))
          (li "Módulos carregados: " (code "lsmod"))
          (li "Carga de módulos: " (code "modprobe"))
          (li "Descarga de módulos: " (code "rmmod"))
          (li "Mensagens do kernel: " (code "dmesg"))
          )))


(slide "Kernel -- combinações de teclas em caso de problema"
       `((ul
          (li "Magic SysRq key")
          (li (code "Alt+SysRQ+b") ": reboot sem desmontar sistemas de arquivos")
          (li (code "Alt+SysRQ+u") ": remonta todos os sistemas de arquivos em modo somente leitura")
          (li (code "Alt+SysRQ+s") ": executa " (i "sync") ", salvando dados da memória em disco")
          (li (code "Alt+SysRQ+e") ": envia SIGTERM para todos os processos, exceto init")
          (li (code "Alt+SysRQ+i") ": envia SIGKILL para todos os processos, exceto init")
          (li (code "Alt+SysRQ+l") ": envia SIGKILL para todos os processos, inclusive init")
          (li (code "/proc/sys/kernel/sysrq"))
          )))


(slide "Sistema de arquivos /proc"
       `(ul
         (li "Interface para estruturas de dados do kernel")
         (li (code "/proc/cpuinfo") ": informações sobre o processador")
         (li (code "/proc/meminfo") ": informações sobre a memória")
         (li (code "/proc/<pid>") ": informações sobre processo de identificador " (code "<pid>"))
         (li (code "/proc/<pid>/cmdline") ": linha de comando executada para gerar o processo de identificador " (code "<pid>"))
         (li (code "/proc/<pid>/environ") ": ambiente do processo de identificador " (code "<pid>"))
         (li (code "/proc/<pid>/fdinfo") ": arquivos abertos pelo processo de identificador " (code "<pid>"))
         (li (code "/proc/cmdline") ": argumentos passados para o kernel em tempo de boot")))


(slide "Informações sobre o hardware -- dmidecode"
       `((ul
          (li "Mostra informações sobre o hardware em que está sendo executado o systema")
          )))



;;;
;;; Emacs
;;;
(slide "Emacs"
       `((img (@ (src "img/real_programmers.png")))
         (a (@ (href "http://xkcd.com/378/")) "http://xkcd.com/378/")))


(slide "Emacs -- histórico"
       `((ul
          (li "Editor Macros")
          (li "Desenvolvimento iniciado em 1976")
          (li "Primeiro software do projeto GNU")
          (li "Início: conjunto de macros em TECO")
          (li "Extensível em Lisp a partir de 1984"))))


(slide "Emacs -- características"
       `((ul
          (li "Extensível (programável) em Lisp")
          (li "Centenas de " (i "modos") " (extensões) para as mais diversas tarefas (edição de código, e-mail, tocador de música, navegadores etc)")
          (li "Modo gráfico e modo \"texto\"")
          (li "Modo servidor"))))


(slide "Emacs -- combinações de teclas"
       `((ul
          (li (code "M") ": tecla meta.  Normalmente associada a ALT ou ESC")
          (li (code "C") ": tecla control.  Associada a CTRL")
          (li (code "S") ": tecla shift"))
         (h3 "Combinações")
         (ul
          (li (code "M-x") ": pressionar " (code "ALT") " e, em seguida, " (code "x") ", mantendo " (code "ALT") ", pressionada.  Se usada " (code "ESC") " em vez de " (code "ALT") ", deve-se soltar " (code "ESC") " antes de pressionar " (code "x"))
          (li (code "C-x") ": pressionar " (code "CTRL") " e, em seguida, " (code "x") ", mantendo " (code "ALT") ", pressionada.")
          (li (code "C-x 1") ": pressionar " (code "CTRL") " e, em seguida, " (code "x") ", mantendo " (code "ALT") ", pressionada.  Depois de liberadas " (code "CTRL") " e " (code "x") ", pressionar " (code "1")))))


(slide '("Emacs -- " (i "buffers") " e janelas")
       `((ul
          (li (i "Buffer") ": área de memória onde Emacs coloca conteúdo de arquivos")
          (li "Janela: área na tela onde buffers são exibidos")
          (li "É possível haver múltiplas janelas exibindo o mesmo buffer")
          (li "Fechar uma janela não implica em fechar um buffer")
          )
         (h3 "Comandos")
         (ul
          (li (code "C-x C-f") ": abre um arquivo em um buffer")
          (li (code "C-x k") ": fecha buffer")
          (li (code "C-x C-s") ": salva buffer -- escreve conteúdo do buffer em arquivo")
          (li (code "C-x C-b") ": lista os buffers abertos")
          (li (code "C-x b") ": troca de buffer")
          (li (code "C-x 1") ": deixa apenas uma janela visível")
          (li (code "C-x 2") ": segmenta a janela corrente em duas, verticalmente")
          (li (code "C-x 3") ": segmenta a janela corrente em duas, horizontalmente")
          (li (code "C-x o") ": move o cursor para outra janela")
          )))


(slide "Emacs -- modos"
       `((p "Emacs possui diversos modos de edição/operação. Estes modos são dividos em duas categorias:")
         (ul
          (li "modo principal (major-mode):  é exibido ente parênteses na penúltima linha da tela e é inicialmente definido pelo Emacs, de forma automática, baseado no tipo do arquivo. Pode ser alterado a qualquer momento. Por exemplo, o comando: " (code "M-x c-mode") " ativa o modo para edição de programas fonte da linguagem C.")
          (li "modo secundário (minor-mode):  complementa o modo principal e adiciona recursos menores"))))


(slide "Emacs -- movimentação"
       `((ul
          (li (code "C-a") ": move cursor para o início da linha")
          (li (code "C-e") ": move cursor para o final da linha")
          (li (code "M-<") ": move cursor para o início do buffer")
          (li (code "M->") ": move cursor para o final do buffer"))))


(slide "Emacs -- edição"
       `((ul
          (li (code "C-d") ": apaga o caractere sob o cursor")
          (li (code "C-k") ": apaga da posição do cursor até o fim da linha")
          (li (code "C-SPC") ": marca início e fim de região (bloco)")
          (li (code "M-w") ": copia região")
          (li (code "C-y") ": restaura o último bloco de texto excluído (cola, " (i "paste") ")")
          (li (code "M-y") ": permite selecionar qual dos blocos anteriormente excluídos será restaurado (usado em sequência ao " (code "C-y") ")"))))


(slide "Emacs -- minibuffer e comandos interativos"
       `((ul
          (li (code "M-x") ": abre a linha de comando do Emacs")
          (li (code "C-g") ": cancela"))))


(slide "Emacs -- pesquisa"
       `((ul
          (li (code "C-s") ": pesquisa para frente")
          (li (code "C-r") ": pesquisa para trás"))))


(slide "Emacs -- substituição"
       `((ul
          (li (code "M-%") ": substituição simples")
          (li (code "M-x query-replace-regexp") ": substituição com expressão regulares"))))


(slide "Emacs -- miscelânea"
       `((ul
          (li (code "M-x doctor") ": psicoterapeuta")
          (li (code "M-x tetris") ": tetris")
          (li (code "M-x zone"))
          (li (code "M-x butterfly")))))



;;; Shell script

(slide "Programação com shell -- shell scripting"
       `((ul
          (li "Uso das estruturas do shel para programação")
          (li "Prática para tarefas \"simples\"")
          (li "Como linguagem de programação de uso geral, shell é pobre mas, para automatização de tarefas que seriam executadas manualmente no próprio shell, é uma ferramenta valiosa"))))


(slide "Shell scripting -- caracteres especiais"
       `((ul
          (li (code "#") ": comentário")
          (li (code ";") ": separador de comandos")
          (li (code ".") ": sinônimo do comando " (code "source"))
          (li (code "\\") ": caracter de escape")
          (li (code "`") ": substituição de comandos")
          (li (code ":") ": comando nulo")
          (li (code "* . [] {} ?") ": globbing")
          (li (code "$") ": substituição de variável")
          (li (code "|") ": pipes")
          (li (code "< > << >>") ": redirecionamento de entrada e saída"))))


(slide "Shell scripting -- variáveis especiais"
       `((ul
          (li (code "$0") ": caminho para o arquivo do script")
          (li (code "$<n>") ": argumento " (code "<n>"))
          (li (code "$#") ": número de argumentos")
          (li (code "$?") ": valor de retorno")
          (li (code "$$") ": identificador do processo do script")
          (li (code "$!") ": identificador do último processo executado em background")
          (li (code "\"$*\"") ": lista de argumentos (como uma única string)")
          (li (code "\"$@\"") ": lista de argumentos (como strings separadas)")
          )))


(slide "Shell scripting -- condicionais"
       `((pre "
if <teste>
then
    <alternativa 1>
else
    <laternativa 2>
fi")))


(slide "Shell scripting -- testes"
       `((pre "
if grep \"mario:\" /etc/passwd > /dev/null; then
    echo \"O usuario mario existe\"
else
    echo \"O usuario mario NAO existe\"
fi")))


(slide "Shell scripting -- testes"
       `((pre "
if [ \"`grep processor /proc/cpuinfo | wc -l`\" -eq 1 ]; then
    echo \"Sistema com um processador\"
else
    echo \"Sistema com mais de um processador\"
fi")))


(slide "Shell scripting -- operadores de teste binários aritméticos"
       `((ul
          (li (code "-eq") ": igual a")
          (li (code "-ne") ": diferente de")
          (li (code "-lt") ": menor que")
          (li (code "-le") ": menor que ou igual a")
          (li (code "-gt") ": maior que")
          (li (code "-ge") ": maior que ou igual a"))))


(slide "Shell scripting -- operadores de teste binários para strings"
       `((ul
          (li (code "=") " ou " (code "==") ": igual a")
          (li (code "!=") ": diferente de"))))


(slide "Shell-scripting -- operadores de teste de arquivos"
       `((ul
          (li (code "-e") ": o arquivo existe?")
          (li (code "-f") ": o arquivo é comum?")
          (li (code "-d") ": o arquivo é um diretório?")
          (li (code "-h") " ou " (code "-L") ": o arquivo é um link?")
          (li (code "-s") ": o tamanho do arquivo é maior que zero?")
          (li (code "-r") ": o arquivo tem permissão de leitura?")
          (li (code "-w") ": o arquivo tem permissaõ de escrita?")
          (li (code "-x") ": o arquivo tem permissão de execução?")
          )))


(slide "Shell scripting -- iteração com for"
       `((ul
          (li (code "seq") ": gera seqüências"))
         (pre "
for <variavel> in <sequencia>
do
    <comandos>
done
")))


(slide "Shell scripting -- iteração com for"
       `((pre "
for i in `seq 1 10`; do
    echo $i
done
")))


(slide "Serviços e servidores -- SSH"
       `(ul
         (li (i "Secure Shell"))
         (li "Criptografia")
         (li "Servidor: OpenSSH")))


(slide "Serviços & servidores -- HTTP"
       `((ul
          (li (i "Hyper Text Transfer Protocol"))
          (li "Exemplos de servidores: Apache, lighthttp")
          (li "CGI")
          (li "Linguagens de programação (PHP, Python, Perl ...)")
          (li "Web frameworks:"
              (ul
               (li "Django (Python)")
               (li "Flask (Python)")
               (li "web2py (Python)")
               (li "Ruby on Rails (Ruby)")
               (li "Awful (Scheme)")
               )))))


(slide "Serviços e servidores -- SMTP"
       `((ul
          (li (i "Simple Mail Transfer Protocol"))
          (li "Exemplos de servidores: sendmail, postfix, qmail")
          )))


(slide "Serviços e servidores -- Backup"
       `((ul
          (li "rsync")
          (li "BackupPC")
          (li "Bacula")
          )))


(slide "Serviços e servidores -- DNS"
       `((ul
          (li (i "Domain Name Service"))
          (li "Exemplos de servidores: bind, djbdns")
          )))


;;;

(slide "Considerações sobre a administração de servidores"
       `((ul
          (li "Simplicidade")
          (li "Registro (documentação) das atividades (quando, por que)")
          (li "Comunicação com pessoal técnico")
          )))


) ; end presentation


(with-output-to-port (current-error-port)
  (lambda ()
    (print *num-slides* " slides")))