(use sxml-transforms)

(define slides-html (make-parameter "slides.html"))

(define *num-slides* 0)

(define (slides-inc!)
  (set! *num-slides* (+ 1 *num-slides*)))


(define sxml->html
  (let ((rules `((literal *preorder* . ,(lambda (t b) b))
                 . ,universal-conversion-rules*)))
    (lambda (sxml)
      (with-output-to-file (slides-html)
        (lambda ()
          (SRV:send-reply (pre-post-order* sxml rules)))))))

(define (slide title-text . content)
  (slides-inc!)
  `(div (@ (class "slide"))
        (h1 ,title-text)
        ,content))


(define (cover title-text . content)
  `(div (@ (class "slide cover"))
        (h1 ,title-text)
        ,content))


(define (presentation . slides)
  (sxml->html
   `(html
     (head
      (meta (@ (http-equiv "Content-Type")
               (content "text/html; charset=UTF-8")))
      (link (@ (rel "stylesheet")
               (type "text/css")
               (media "screen, projection")
               (href "css/show.css")))
      (link (@ (rel "stylesheet")
               (type "text/css")
               (media "screen, projection")
               (href "css/slides.css")))
      (script (@ (src "js/slidy.js")
                 (type "text/javascript"))))
     (body ,slides))))
